%ydbguiReplication ; YottaDB Replication; 03-29-2023
	;#################################################################
	;#                                                               #
	;# Copyright (c) 2023 YottaDB LLC and/or its subsidiaries.       #
	;# All rights reserved.                                          #
	;#                                                               #
	;#   This source code contains the intellectual property         #
	;#   of its copyright holder(s), and is made available           #
	;#   under a license.  If you do not know the terms of           #
	;#   the license, please stop and do not read further.           #
	;#                                                               #
	;#################################################################
	;
	quit
	;
getInstanceHeader()
	new res,ret,cmd,shellResult,cnt,line
	new prevChar,param1,param2,charCnt,char,paramCnt,found,array
	;
	; check for instance file existance
	new replInstanceFile set replInstanceFile=""
	set replInstanceFile=$ztrnlnm("ydb_repl_instance")
	if replInstanceFile="" set replInstanceFile=$ztrnlnm("gtm_repl_instance")
	if replInstanceFile="" goto getInstanceHeaderQuit
	if $zsearch(replInstanceFile,-1)="" goto getInstanceHeaderQuit
	;
	; execute the call
	set cmd="$ydb_dist/mupip replicate -editinstance -show "_replInstanceFile
	set ret=$$runShell^%ydbguiUtils(cmd,.shellResult)
	if ret'=0 do  goto getInstanceHeaderQuit
	. set res("status")="ERROR"
	. set res("error","description")="The following error was returned: "_ret
	. merge res("error","dump")=shellResult
	;
	; parse the response and extract the values
	set cnt="" for  set cnt=$order(shellResult(cnt)) quit:cnt=""  do
	. set line=shellResult(cnt)
	. quit:$zfind(line,"YDB-I-MUREPLSHOW")
	. quit:line=""
	. quit:$zfind(line,"---")
	. quit:$zfind(line,"File Header")
	. set (prevChar,param1,param2)="",found=0
	. for charCnt=1:1:$zlength(line) do
	. . set char=$zextract(line,charCnt)
	. . if char=" ",prevChar=" " do
	. . . set param1=$zextract(line,1,charCnt-1)
	. . . for paramCnt=charCnt:1:$zlength(line) do  quit:found
	. . . . if $zextract(line,paramCnt,paramCnt)'=" " set param2=$zextract(line,paramCnt,$zlength(line)),found=1
	. . else  set prevChar=char
	. ;
	. if line'="" do
	. . if param1="" set array(cnt,"name")=$zpiece(line," ",1,4),array(cnt,"value")=$zpiece(line," ",5)
	. . else  set array(cnt,"name")=$$R^%TRIM(param1),array(cnt,"value")=param2
	. zkill array(cnt)
	;
	merge res=array
	set res("result")="OK"
	;
getInstanceHeaderQuit
    quit *res
	;
