/****************************************************************
 *                                                              *
 * Copyright (c) 2022-2023 YottaDB LLC and/or its subsidiaries.      *
 * All rights reserved.                                         *
 *                                                              *
 * This source code contains the intellectual property          *
 * of its copyright holder(s), and is made available            *
 * under a license.  If you do not know the terms of            *
 * the license, please stop and do not read further.            *
 *                                                              *
 ****************************************************************/

app.userSettings = {
    rest: {
        timeout: {
            short: 10000,     // 10 seconds
            long: 3600000     // 1 hour
        }
    },
    dashboard: {
        flashInterval: 500,
        storageRanges: [
            {
                min: 0,
                max: 70,
                class: 'ydb-status-green',
                flash: false
            },
            {
                min: 71,
                max: 90,
                class: 'ydb-status-amber',
                flash: false
            },
            {
                min: 91,
                max: 97,
                class: 'ydb-status-red',
                flash: false
            },
            {
                min: 98,
                max: 100,
                class: 'ydb-status-red',
                flash: true
            },
        ],
        regionRanges: [
            {
                min: 0,
                max: 70,
                class: 'ydb-status-green-readable',
                flash: false
            },
            {
                min: 71,
                max: 90,
                class: 'ydb-status-amber',
                flash: false
            },
            {
                min: 91,
                max: 97,
                class: 'ydb-status-red',
                flash: false
            },
            {
                min: 98,
                max: 100,
                class: 'ydb-status-red',
                flash: false
            },
        ],
        autoExtend: [
            {
                min: 0,
                max: 2,
                class: 'ydb-status-red',
                flash: true
            },
            {
                min: 3,
                max: 5,
                class: 'ydb-status-red',
                flash: false
            },
            {
                min: 6,
                max: 10,
                class: 'ydb-status-amber',
                flash: false
            },
            {
                min: 11,
                max: 999999999,
                class: 'ydb-status-green',
                flash: false
            },
        ],
        manualExtend: [
            {
                min: 0,
                max: 10,
                class: 'ydb-status-red',
                flash: true
            },
            {
                min: 11,
                max: 20,
                class: 'ydb-status-red',
                flash: false
            },
            {
                min: 21,
                max: 30,
                class: 'ydb-status-amber',
                flash: false
            },
            {
                min: 31,
                max: 99999999999,
                class: 'ydb-status-green',
                flash: false
            },
        ],
        activeJournalRanges: [
            {
                min: 0,
                max: 70,
                class: 'range-bg-green'
            },
            {
                min: 71,
                max: 90,
                class: 'range-bg-amber'
            },
            {
                min: 91,
                max: 100,
                class: 'range-bg-red'
            },

        ]
    },
    globalViewer: {
        options: {
            table: {
                buffering: {
                    initialFetchSize: 600,
                    maxSize: 1000,
                    lazyFetchSize: 100,
                    startFetchingPages: 3
                },
                maxDataLength: 512,            // The maximum length of the $GET string. If longer, we will fetch it with a button)
            },
            pathBar: {
                fetchAt: 2,
                fetchAllSize: 10
            },
            tab: {
                maxLengthCaption: 25,
            },
            menuLastUsedItemsCount: 10,
            lastUsedMaxItems: 100,
        },
        themes: {
            light: {
                background: 'white',
                border: 'solid gray 1px;',
                titleBar: {
                    background: 'white',
                    globalName: '#0000ff',
                    parens: '#ff00ff',
                    numbers: '#ff0000',
                    strings: '#00aa00',
                    comma: '#600000',
                    colon: '#ff0000',
                    star: '#ff0000'
                },
                toolbar: {
                    background: 'black',
                    icons: 'orange'
                },
                table: {
                    bookmarkColor: 'red',
                    headers: {
                        bookmark: {
                            fontSize: '11px',
                            back: '#808080',
                        },
                        fontSize: '14px',
                        fore: '#0000ff',
                        back: '#d3d3d3',
                    },
                    content: {
                        background: '#ffffff',
                        globalName: '#0000ff',
                        parens: '#ff00ff',
                        numbers: '#ff0000',
                        strings: '#00aa00',
                        comma: '#600000',
                        fontSize: 16,
                        values: {
                            showPieces: 'pills',            // yes, no, pills
                            data: {
                                fore: '#00a000',
                            },
                            pieceChar: {
                                fore: '#ff0000',
                                back: '#a8ffca',
                                char: '^',
                            },
                            piecePills: {
                                paddingLr: '12px',
                                borderRadius: '5px',
                                back: '#a8ffca',
                                fore: '#004cff'
                            },
                        },
                        bookmarks: {
                            fore: '#0000ff',
                            back: '#c0c0c0',
                        }
                    },
                }
            },
            dark: {
                background: 'white',
                border: 'solid gray 1px;',
                titleBar: {
                    background: 'white',
                    globalName: '#0000ff',
                    parens: '#ff00ff',
                    numbers: '#ff0000',
                    strings: '#00aa00',
                    comma: '#600000',
                    colon: '#ff0000',
                    star: '#ff0000'
                },
                toolbar: {
                    background: 'black',
                    icons: 'orange'
                },
                table: {
                    bookmarkColor: 'red',
                    headers: {
                        bookmark: {
                            fontSize: '11px',
                            back: '#808080',
                        },
                        fontSize: '14px',
                        fore: '#0000ff',
                        back: '#d3d3d3',
                    },
                    content: {
                        background: '#ffffff',
                        globalName: '#fbf074',
                        parens: '#ff0033',
                        numbers: '#00ffff',
                        strings: '#ee0000',
                        comma: '#d0d0d0',
                        fontSize: 16,
                        values: {
                            showPieces: 'pills',            // yes, no, pills
                            data: {
                                fore: '#00e600',
                            },
                            pieceChar: {
                                fore: '#7affa7',
                                back: '#6666ff',
                                char: '^',
                            },
                            piecePills: {
                                paddingLr: '12px',
                                borderRadius: '5px',
                                back: '#bebef9',
                                fore: '#0033ff'
                            },
                        },
                        bookmarks: {
                            fore: '#0000ff',
                            back: '#c0c0c0',
                        }
                    },
                }
            }
        },
        defaultTheme: 'light',
        lastUsed: [
        ]
    }
};

app.userSettings.defaults = {
    backup: {
        target: '/',
        replTarget: '/'
    }
}
// In order to simplify settings-structures updates, we use a version number. If version is different we will update
app.userSettings.current = {version: 1.11};

// we make a difference between settings and lists of recently used items...
// Therefore, we use one item for settings, which comprehend the whole settings
// and separate items for the recently used items, which can be big
//

// current valid keys are: 'dashboard', 'gViewer'

app.ui.storage.init = () => {
    if (typeof (Storage) !== "undefined") {
        // localStorage is supported, check if already initialized
        const current = app.ui.storage.get('current');

        if (current === null || storageReset === true || app.userSettings.current.version !== current.version) {
            console.log('Initializing the local storage...');

            // perform initialization
            app.ui.storage.save('dashboard', app.userSettings.dashboard);
            app.ui.storage.save('gViewer', app.userSettings.globalViewer);
            app.ui.storage.save('current', app.userSettings.current);
            app.ui.storage.save('defaults', app.userSettings.defaults);

        } else {
            //fetch settings
            app.userSettings.dashboard = app.ui.storage.get('dashboard');
            app.userSettings.globalViewer = app.ui.storage.get('gViewer')
            app.userSettings.defaults = app.ui.storage.get('defaults')
        }

    } else {
        // No web storage Support.
        console.log('Your browser does NOT support local storage. You can not store and change settings.')
    }
};

app.ui.storage.save = (key, object) => {
    window.localStorage.setItem(key, JSON.stringify(object))
};

app.ui.storage.get = key => {
    return JSON.parse(window.localStorage.getItem(key))

};

